//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2022-01-05 09:17:03 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------

using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Infrastructure.Extention;
using Microsoft.AspNetCore.Hosting;
using Microsoft.EntityFrameworkCore;
using IRaCIS.Core.Application.Contracts;
using IRaCIS.Core.Infra.EFCore;
using User = IRaCIS.Core.Domain.Models.User;

namespace IRaCIS.Core.Application.Services
{
    /// <summary>
    /// SystemDocumentService
    /// </summary>	
    [ApiExplorerSettings(GroupName = "Trial")]
    public class SystemDocumentService : BaseService, ISystemDocumentService
    {

        private readonly IRepository<SystemDocument> _systemDocumentRepository;

        public SystemDocumentService( IRepository<SystemDocument> systemDocumentRepository)
        {
            _systemDocumentRepository = systemDocumentRepository;
        }



        /// <summary>
        /// 管理端列表
        /// </summary>
        /// <param name="querySystemDocument"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<PageOutput<SystemDocumentView>> GetSystemDocumentListAsync(SystemDocumentQuery querySystemDocument)
        {
            var systemDocumentQueryable = _systemDocumentRepository.AsQueryable(true)
               .WhereIf(!string.IsNullOrEmpty(querySystemDocument.Name), t => t.Name.Contains(querySystemDocument.Name))
               .WhereIf(querySystemDocument.FileTypeId != null, t => t.FileTypeId == querySystemDocument.FileTypeId)
               .ProjectTo<SystemDocumentView>(_mapper.ConfigurationProvider, new { token = _userInfo.UserToken, userId = _userInfo.Id });

            return await systemDocumentQueryable.ToPagedListAsync(querySystemDocument.PageIndex, querySystemDocument.PageSize, querySystemDocument.SortField, querySystemDocument.Asc);
        }

        public async Task<IResponseOutput> AddOrUpdateSystemDocumentAsync(AddOrEditSystemDocument addOrEditSystemDocument)
        {
            if (addOrEditSystemDocument.Id == null)
            {
                var entity = _mapper.Map<SystemDocument>(addOrEditSystemDocument);


                if (await _systemDocumentRepository.AnyAsync(t => t.FileTypeId == addOrEditSystemDocument.FileTypeId && t.Name == addOrEditSystemDocument.Name,true))
                {
                    return ResponseOutput.NotOk("同类型已存在该文件名");
                }

                await _systemDocumentRepository.AddAsync(entity, true);

                return ResponseOutput.Ok(entity.Id.ToString());

            }
            else
            {
                var document = await _systemDocumentRepository.Where(t => t.Id == addOrEditSystemDocument.Id, true,true).Include(t => t.NeedConfirmedUserTypeList).FirstOrDefaultAsync();

                if (document == null) return Null404NotFound(document);

                if (await _systemDocumentRepository.AnyAsync(t => t.FileTypeId == addOrEditSystemDocument.FileTypeId && t.Name == addOrEditSystemDocument.Name && t.Id != addOrEditSystemDocument.Id,true))
                {
                    return ResponseOutput.NotOk("同类型已存在该文件名");
                }


                _mapper.Map(addOrEditSystemDocument, document);

                if (document.FileTypeId != addOrEditSystemDocument.FileTypeId)
                {
                    var rootPath = Directory.GetParent(_hostEnvironment.ContentRootPath.TrimEnd('\\')).IfNullThrowException().FullName;
                    var beforeFilePath = Path.Combine(rootPath, document.Path);

                    document.Path = document.Path.Replace(document.FileTypeId.ToString(), addOrEditSystemDocument.FileTypeId.ToString());

                    var nowPath = Path.Combine(rootPath, document.Path);

                    if (File.Exists(beforeFilePath))
                    {
                        File.Move(beforeFilePath, nowPath, true);
                        File.Delete(beforeFilePath);
                    }

                }
                var success = _repository.SaveChangesAsync();

                return ResponseOutput.Ok(document.Id.ToString());
            }



        }


        [HttpDelete("{systemDocumentId:guid}")]
        public async Task<IResponseOutput> DeleteSystemDocumentAsync(Guid systemDocumentId)
        {

            if (await _repository.Where<SystemDocument>(t => t.Id == systemDocumentId).AnyAsync(u => u.SystemDocConfirmedUserList.Any()))
            {
                return ResponseOutput.NotOk("该文档下已有签名的用户");
            }

            var success = await _repository.BatchDeleteAsync<SystemDocument>(t => t.Id == systemDocumentId);

            return ResponseOutput.Result(success);
        }


        /// <summary>
        /// 获取需要签署的系统文档列表
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public async Task<PageOutput<UnionDocumentWithConfirmInfoView>>  GetWaitSignSysDocList(SystemDocumentQuery querySystemDocument)
        {


            var query = from sysDoc in _systemDocumentRepository.Where(t => t.NeedConfirmedUserTypeList.Any(t => t.NeedConfirmUserTypeId == _userInfo.UserTypeId))
                    .WhereIf(!string.IsNullOrEmpty(querySystemDocument.Name), t => t.Name.Contains(querySystemDocument.Name))
                    .WhereIf(querySystemDocument.FileTypeId != null, t => t.FileTypeId == querySystemDocument.FileTypeId)
                        join confirm in _repository.GetQueryable<SystemDocConfirmedUser>() on new { ConfirmUserId = _userInfo.Id, SystemDocumentId = sysDoc.Id } equals new { confirm.ConfirmUserId, confirm.SystemDocumentId } into cc
                        from confirm in cc.DefaultIfEmpty()

                        join user in _repository.GetQueryable<User>() on _userInfo.Id equals user.Id

                        select new UnionDocumentWithConfirmInfoView()
                        {
                            IsSystemDoc = true,

                            Id = sysDoc.Id,
                            CreateTime = sysDoc.CreateTime,
                            IsDeleted = sysDoc.IsDeleted,
                            SignViewMinimumMinutes = sysDoc.SignViewMinimumMinutes,
                            Name = sysDoc.Name,
                            Path = sysDoc.Path,
                            FileType = sysDoc.FileType.Value,
                            UpdateTime = sysDoc.UpdateTime,

                            FullFilePath = sysDoc.Path + "?access_token=" + _userInfo.UserToken,

                            ConfirmUserId = confirm.ConfirmUserId,
                            ConfirmTime = confirm.ConfirmTime,
                            RealName = user.LastName + " / " + user.FirstName,
                            UserName = user.UserName,
                            UserTypeShortName = user.UserTypeRole.UserTypeShortName
                        };

            return await query.Where(t=>t.ConfirmTime==null).ToPagedListAsync(querySystemDocument.PageIndex, querySystemDocument.PageSize, querySystemDocument.SortField, querySystemDocument.Asc); 



        }

    }
}
