﻿using IRaCIS.Core.Domain.Share;
using MediatR;
using System;

namespace IRaCIS.Core.Application.MediatR.CommandAndQueries
{

    public class QAMessageRequest:IRequest<bool>
    {
        //有一部分QA 消息 在 AutoFac AOP中，但是由于直接服务生成API  上面切入的AOP会失效，
        //因为采用进程内消息通信，可以解耦代码，避免写在一起，影响阅读，专注于业务逻辑
        public NoticeType  MessageType { get; set; }

        public Guid SubjectVisitId { get; set; }

        //用于关联关系记录 删除的时候，处理消息
        public Guid QCChallengeId { get; set; }

        //用于关联关系记录 删除的时候，处理消息
        public Guid QCChallengeReplyId { get; set; }

    }
}