﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations;


namespace IRaCIS.Core.Infra.EFCore.Common.Dto
{
    public class SetInspectionEnumValueDto
    {
        [NotDefault]
        public Guid TrialId { get; set; }

        public List<SetInspectionEnum> Items { get; set; }

    }


    /// <summary>
    /// 复制
    /// </summary>
    public class CopyFrontAuditConfigItemDto
    {
        public Guid ParentId { get; set; }

        public Guid ChildId { get; set; }
    }

    /// <summary>
    /// 稽查数据
    /// </summary>
    public class InspectionData
    { 
         public dynamic Data { get; set; }

         public InspectionGeneralData Inspection { get; set; }
    }

    /// <summary>
    /// 稽查外层数据
    /// </summary>
    public class InspectionGeneralData
    {
        /// <summary>
		/// 项目iD
		/// </summary>
        public Guid? TrialId { get; set; }

        /// <summary>
        /// 中心
        /// </summary>
        public Guid? SiteId { get; set; }

        /// <summary>
        /// 受试者
        /// </summary>
        public Guid? SubjectId { get; set; }

        /// <summary>
        /// 访视
        /// </summary>
        public Guid? SubjectVisitId { get; set; }

        /// <summary>
		/// 创建人名称
		/// </summary>
		public string CreateUserName { get; set; }

        /// <summary>
        /// 项目名称
        /// </summary>
        public string TrialName { get; set; }

        /// <summary>
        /// 中心名称
        /// </summary>
        public string SiteName { get; set; }

        /// <summary>
        /// 受试者名称
        /// </summary>
        public string SubjectCode { get; set; }

        /// <summary>
        /// 访视名称
        /// </summary>
        public string SubjectVisitName { get; set; }

        /// <summary>
        /// 角色名称
        /// </summary>
        public string RoleName { get; set; }

        /// <summary>
        /// 中心Code
        /// </summary>
        public string SiteCode { get; set; }

        /// <summary>
        /// 项目编码
        /// </summary>
        public string ResearchProgramNo { get; set; }
    }

    public class SetInspectionEnum
    {
        public string Identification { get; set; }

        public string Json { get; set; }
    }


    public class TableList
    {
        public string Name { get; set; }

        public string Remake { get; set; }
    }





}
